/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
	"fmt"
)

// OperationRequestSort - struct for OperationRequestSort
type OperationRequestSort struct {
	SortRequest *SortRequest
}

// SortRequestAsOperationRequestSort is a convenience function that returns SortRequest wrapped in OperationRequestSort
func SortRequestAsOperationRequestSort(v *SortRequest) OperationRequestSort {
	return OperationRequestSort{
		SortRequest: v,
	}
}

// Unmarshal JSON data into one of the pointers in the struct
func (dst *OperationRequestSort) UnmarshalJSON(data []byte) error {
	var err error
	// this object is nullable so check if the payload is null or empty string
	if string(data) == "" || string(data) == "{}" {
		return nil
	}

	match := 0
	// try to unmarshal data into SortRequest
	err = newStrictDecoder(data).Decode(&dst.SortRequest)
	if err == nil {
		jsonSortRequest, _ := json.Marshal(dst.SortRequest)
		if string(jsonSortRequest) == "{}" { // empty struct
			dst.SortRequest = nil
		} else {
			match++
		}
	} else {
		dst.SortRequest = nil
	}

	if match > 1 { // more than 1 match
		// reset to nil
		dst.SortRequest = nil

		return fmt.Errorf("data matches more than one schema in oneOf(OperationRequestSort)")
	} else if match == 1 {
		return nil // exactly one match
	} else { // no match
		return fmt.Errorf("data failed to match schemas in oneOf(OperationRequestSort)")
	}
}

// Marshal data from the first non-nil pointers in the struct to JSON
func (src OperationRequestSort) MarshalJSON() ([]byte, error) {
	if src.SortRequest != nil {
		return json.Marshal(&src.SortRequest)
	}

	return nil, nil // no data in oneOf schemas
}

// Get the actual instance
func (obj *OperationRequestSort) GetActualInstance() interface{} {
	if obj == nil {
		return nil
	}
	if obj.SortRequest != nil {
		return obj.SortRequest
	}

	// all schemas are nil
	return nil
}

type NullableOperationRequestSort struct {
	value *OperationRequestSort
	isSet bool
}

func (v NullableOperationRequestSort) Get() *OperationRequestSort {
	return v.value
}

func (v *NullableOperationRequestSort) Set(val *OperationRequestSort) {
	v.value = val
	v.isSet = true
}

func (v NullableOperationRequestSort) IsSet() bool {
	return v.isSet
}

func (v *NullableOperationRequestSort) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOperationRequestSort(val *OperationRequestSort) *NullableOperationRequestSort {
	return &NullableOperationRequestSort{value: val, isSet: true}
}

func (v NullableOperationRequestSort) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOperationRequestSort) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
